package ProductApp;


/**
* ProductApp/ProductHelper.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from ProductApp.idl
* Friday, April 21, 2017 9:43:36 PM PET
*/

abstract public class ProductHelper
{
  private static String  _id = "IDL:ProductApp/Product:1.0";

  public static void insert (org.omg.CORBA.Any a, ProductApp.Product that)
  {
    org.omg.CORBA.portable.OutputStream out = a.create_output_stream ();
    a.type (type ());
    write (out, that);
    a.read_value (out.create_input_stream (), type ());
  }

  public static ProductApp.Product extract (org.omg.CORBA.Any a)
  {
    return read (a.create_input_stream ());
  }

  private static org.omg.CORBA.TypeCode __typeCode = null;
  synchronized public static org.omg.CORBA.TypeCode type ()
  {
    if (__typeCode == null)
    {
      __typeCode = org.omg.CORBA.ORB.init ().create_interface_tc (ProductApp.ProductHelper.id (), "Product");
    }
    return __typeCode;
  }

  public static String id ()
  {
    return _id;
  }

  public static ProductApp.Product read (org.omg.CORBA.portable.InputStream istream)
  {
    return narrow (istream.read_Object (_ProductStub.class));
  }

  public static void write (org.omg.CORBA.portable.OutputStream ostream, ProductApp.Product value)
  {
    ostream.write_Object ((org.omg.CORBA.Object) value);
  }

  public static ProductApp.Product narrow (org.omg.CORBA.Object obj)
  {
    if (obj == null)
      return null;
    else if (obj instanceof ProductApp.Product)
      return (ProductApp.Product)obj;
    else if (!obj._is_a (id ()))
      throw new org.omg.CORBA.BAD_PARAM ();
    else
    {
      org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate ();
      ProductApp._ProductStub stub = new ProductApp._ProductStub ();
      stub._set_delegate(delegate);
      return stub;
    }
  }

  public static ProductApp.Product unchecked_narrow (org.omg.CORBA.Object obj)
  {
    if (obj == null)
      return null;
    else if (obj instanceof ProductApp.Product)
      return (ProductApp.Product)obj;
    else
    {
      org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate ();
      ProductApp._ProductStub stub = new ProductApp._ProductStub ();
      stub._set_delegate(delegate);
      return stub;
    }
  }

}
